-- D minor chord

import CsoundExpr.Base
import qualified CsoundExpr.Opcodes as C

import Temporal.Music.Western.P12  

-- | sinusoidal oscilator
instr :: Irate -> SignalOut
instr cps = C.out $ C.oscilA [] (num 3000) cps (gen10 4096 [1])

-- | pythagorean scale from middle C
scale = pyth c1

-- | d minor chord
sco = fmap (instr . double . hz) $ setScale scale $
    line notes +:+ (stretch 2 $ chord notes)
    where notes = [d, f, a, high d]

file = "out.csd"
flags = "-d"

out = csd flags headerMono sco

main = writeFile file $ show out
--main = play "totem" "tmp" "new" out


